package com.czg.resp;

import lombok.Data;

import java.io.Serializable;

/**
 * Result类用于封装请求响应的结果，包含状态码、消息和数据
 * @author GYJ
 */
@Data
public class CzgResult<T> implements Serializable {

    private int code;

    private String msg;

    private T data;

    // 私有构造函数，用于在类内部创建实例，强制通过静态方法来获取Result对象
    private CzgResult(int code, String msg, T data) {
        this.code = code;
        this.msg = msg;
        this.data = data;
    }

    // 以下是三个静态方法，分别用于创建不同状态的Result对象

    // 创建成功的响应结果对象，默认消息和无数据情况
    public static <T> CzgResult<T> success() {
        return new CzgResult<>(200, "操作成功", null);
    }

    // 创建成功的响应结果对象，携带指定的数据
    public static <T> CzgResult<T> success(T data) {
        return new CzgResult<>(200, "操作成功", data);
    }

    // 创建带有自定义消息的成功响应结果对象，携带指定的数据
    public static <T> CzgResult<T> success(String msg, T data) {
        return new CzgResult<>(200, msg, data);
    }

    // 创建失败的响应结果对象，默认消息和无数据情况
    public static <T> CzgResult<T> failure() {
        return new CzgResult<>(500, "操作失败", null);
    }

    // 创建失败的响应结果对象，携带指定的自定义消息
    public static <T> CzgResult<T> failure(String msg) {
        return new CzgResult<>(500, msg, null);
    }

    // 创建带有自定义状态码和消息的失败响应结果对象，无数据情况
    public static <T> CzgResult<T> failure(int code, String msg) {
        return new CzgResult<>(code, msg, null);
    }

    public static <T> CzgResult<T> failure(CzgRespCode respCode) {
        return new CzgResult<>(respCode.getCode(), respCode.getMsg(), null);
    }

    public boolean isSuccess() {
        return code == 200;
    }
}
